POJ 3126 Prime Path

Prime Path
  Prime Path
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 14926 Accepted: 8404

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670


非常基础的BFS的题目,意思就是给你两个四位素数,要求你把从第一个素数变到第二个素数所需要的最少步骤(要求:每次只能变化一个数字,而且每轮变化后的数字也要是素数)。 刚开始我是用for循环以此遍历四个数位的,后来发现总是出错,不能跳出循环,换成四个if也不行。然后我又检查了一下,发现坑我的竟然是判断素数的函数!!粗心啊!!函数写错了!!(x%i==0写成了n%i==0)怎么能对嘛!!,不过还好,现在两个代码都能过了~~~


Code 1:
#include <iostream>
#include <cstdio>
#include <queue>
#include <cmath>
#include <algorithm>
#include <cstring>
using namespace std;
int cas,m,n,vis[10010];
struct point
{
    int x;
    int step;
};
int isp(int x)
{
    for(int i=2; i<=sqrt(x); i++)
        if (x%i==0)
            return 0;
    return 1;
}
int bfs()
{
    queue<point> Q;
    point st,en;
    st.x=m;
    st.step=0;
    Q.push(st);
    while(!Q.empty())
    {
        st=Q.front();
        Q.pop();
        if(st.x==n)
            return st.step;
        for(int i=1;i<= 9;i+=2)
        {
            int s=st.x/10*10+i;
            if(s!=st.x&&!vis[s]&&isp(s))
            {
                vis[s]=1;
                en.x=s;
                en.step=st.step+1;
                Q.push(en);
            }
        }
        for(int i=0;i<=9;i++)
        {
            int s = st.x/100*100+i*10+st.x%10;
            if(s!= st.x&&!vis[s]&&isp(s))
            {
                vis[s] = 1;
                en.x = s;
                en.step = st.step + 1;
                Q.push(en);
            }
        }
        for(int i=0;i<=9;i++)
        {
            int s=st.x/1000*1000+i*100+st.x%100;
            if(s!=st.x&&!vis[s]&&isp(s))
            {
                vis[s] = 1;
                en.x = s;
                en.step = st.step + 1;
                Q.push(en);
            }
        }
        for(int i=1;i<=9;i++)
        {
            int s=i*1000+st.x%1000;
            if(s!=st.x&&!vis[s]&&isp(s))
            {
                vis[s] = 1;
                en.x = s;
                en.step = st.step + 1;
                Q.push(en);
            }
        }
    }
    return -1;
}
int main()
{
    scanf("%d",&cas);
    while(cas--)
    {
        memset(vis,0,sizeof(vis));
        scanf("%d%d",&m,&n);
        vis[m]=1;
        int t=bfs();
        if(t==-1)
            printf("Impossible\n");
        else
            printf("%d\n",t);
    }
    return 0;
}
Code 2:
#include <iostream>
#include <cstdio>
#include <queue>
#include <cmath>
#include <algorithm>
#include <cstring>
using namespace std;
int cas,m,n,s,vis[10010];
int ys[5]= {1,10,100,1000,10000};
struct point
{
    int x;
    int step;
};
int isp(int x)
{
    for(int i=2; i<=sqrt(x); i++)
        if (x%i==0)
            return 0;
    return 1;
}
int bfs()
{
    queue<point> Q;
    point st,en;
    st.x=m;
    st.step=0;
    Q.push(st);
    while(!Q.empty())
    {
        st=Q.front();
        Q.pop();
        if(st.x==n)
            return st.step;
        for(int i=0; i<4; i++)
        {
            for(int j=0; j<=9; j++)
            {
                if(i==0)
                    j++;
                if(i==3&&j==0)
                    j=1;
                s=st.x/ys[i+1]*ys[i+1]+st.x%ys[i]+j*ys[i];
                if(s!=st.x&&!vis[s]&&isp(s))
                {
                    vis[s]=1;
                    en.x=s;
                    en.step=st.step+1;
                    Q.push(en);
                }
            }
        }
    }
    return -1;
}
int main()
{
    scanf("%d",&cas);
    while(cas--)
    {
        memset(vis,0,sizeof(vis));
        scanf("%d%d",&m,&n);
        vis[m]=1;
        int t=bfs();
        if(t==-1)
            printf("Impossible\n");
        else
            printf("%d\n",t);
    }
    return 0;
}


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值